﻿Public Class Constantes

    Public Const FACTOR_TIMER As Short = 100

    Public Const DG_MAX_PATH As Short = 255

    Public Const DG_MAX_PLAY_QUEUE As Short = 30

    '---------------------------------------------------------------------------------
    'Return CODES
    '---------------------------------------------------------------------------------
    Public Const DG_EXIT_SUCCESS As Short = 0
    Public Const DG_EXIT_FAILURE As Short = &H700
    'startvoicerlib errors
    Public Const DG_ERROR_MEMORY_ALLOCATION As Short = &H400
    Public Const DG_ERROR_MAXCARDS As Short = &H401
    Public Const DG_ERROR_FIRMWARE_NOT_FOUND As Short = &H402
    Public Const DG_ERROR_FIRMWARE_IO_TIMEOUT As Short = &H403
    Public Const DG_ERROR_READING_PORTCOUNT As Short = &H404
    Public Const DG_ERROR_LOADING_DEVICEDRIVER As Short = &H405
    Public Const DG_ERROR_CREATING_EVENT As Short = &H406

    'global errors
    Public Const DG_ERROR_DRIVER_CLOSED As Short = &H450
    Public Const DG_ERROR_CARD_OUT_OF_RANGE As Short = &H451
    Public Const DG_ERROR_PORT_OUT_OF_RANGE As Short = &H452
    Public Const DG_ERROR_PARAM_OUTOFRANGE As Short = &H453
    Public Const DG_ERROR_DRIVER_ALREADY_OPEN As Short = &H454
    Public Const DG_ERROR_CONFIGFILE_NOT_FOUND As Short = &H455
    Public Const DG_FEATURE_NOT_SUPPORTED As Short = &H456
    Public Const DG_ERROR_RESOURCE_UNAVAILABLE As Short = &H457
    Public Const DG_ERROR_RESOURCE_FULL As Short = &H458
    Public Const DG_ERROR_INVALIDPARAM As Short = &H459
    Public Const DG_WARNING_OLDFILEFORMAT As Short = &H460

    'threads related errors
    Public Const DG_ERROR_COULD_NOT_CREATE_THREAD As Short = &H500
    Public Const DG_ERROR_THREAD_NOT_RUNNING As Short = &H501
    Public Const DG_ERROR_FIFO_UNAVAILABLE As Short = &H502
    Public Const DG_ERROR_THREAD_ALREADY_RUNNING As Short = &H503

    'playback related errors
    Public Const DG_ERROR_NOT_PLAYING As Short = &H550
    Public Const DG_ERROR_ALREADY_PLAYING As Short = &H551
    Public Const DG_ERROR_PLAY_OPENFILE As Short = &H552
    Public Const DG_ERROR_PLAY_EMPTYLIST As Short = &H553
    Public Const DG_ERROR_AUDIO_FORMAT_UNSUPPORTED As Short = &H554
    Public Const DG_ERROR_PLAY_INVALID_FILENAME As Short = &H555
    Public Const DG_ERROR_PLAY_BUFFER_FULL As Short = &H556

    'record related errors
    Public Const DG_ERROR_REC_STOPPING As Short = &H600
    Public Const DG_ERROR_REC_OPENFILE As Short = &H601
    Public Const DG_ERROR_REC_ALREADY_RECORDING As Short = &H602
    Public Const DG_ERROR_REC_NOT_RECORDING As Short = &H603

    'conversion related errors
    Public Const DG_ERROR_CONV_SOURCE As Short = &H701
    Public Const DG_ERROR_CONV_TARGET As Short = &H702
    Public Const DG_ERROR_CONV As Short = &H703

    'EEPROM related ERRORS
    Public Const DG_ERROR_ADDRESS_OUT_OF_RANGE As Short = &H770
    Public Const DG_ERROR_EEPROM_PROTECTED As Short = &H771

    Public Const DG_ERROR_SERIAL_FAILURE As Short = &H1000

    'EEPROM address range
    Public Const EEPROM_MIN_ADD As Short = &H70
    Public Const EEPROM_MAX_ADD As Short = &H7F

    Public Const DG_ENABLE_AGC As Short = 0
    Public Const DG_DISABLE_AGC As Short = 1

    'Public Const TRUE as Short = 1
    'Public Const FALSE as Short = 0


    '/* gsm definitions */
    Public Const ENCODE As Short = 1
    Public Const DECODE As Short = 0
    Public Const FAST As Short = 1
    'Public Const USE_FLOAT_MUL
    Public Const TAM_GSM As Short = 160
    'Public Const	GSM_TABLE_C


    'status dos eventos OnPlayStop e OnRecordStop
    Public Const ssNormal As Short = 0
    Public Const ssDigitReceived As Short = 1
    Public Const ssAbnormal As Short = 2
    Public Const ssStopped As Short = 3

    Public Const dtDTMF As Short = 1
    Public Const dtMFP As Short = 2

    'Channel Status
    Public Const spFlashing As Short = 0
    Public Const spDialing As Short = 1
    Public Const spNone As Short = 2
    Public Const spWaitingDigits As Short = 3
    Public Const spOffHook As Short = 4

    'Dialtypes
    Public Const dtPulse As Short = 0
    Public Const dtTone As Short = 1
    Public Const dtMFT As Short = 2
    Public Const dtMFF As Short = 3
    Public Const dtCustomMF As Short = 4
    Public Const dtCustonTone1 As Short = 5
    Public Const dtCustonTone2 As Short = 6
    Public Const dtDirectMF As Short = 7

    'GetDigits States
    Public Const edOff As Short = 0
    Public Const edWaiting As Short = 1
    Public Const edMaxDigits As Short = 2
    Public Const edDigitTimeOut As Short = 3
    Public Const edInterDigitTimeOut As Short = 4
    Public Const edTermDigit As Short = 5
    Public Const edDigitOverMessage As Short = 6

    'AskForGroupB types
    Public Const DG_A3_COMPELED As Short = 0
    Public Const DG_A3_PULSED As Short = 1

    'CONSTANTS of COMMANDS IN DG_CONFIG_E1_HANDLE
    Public Const E1CFG_SEIZURE_TIMEOUT As Short = 0
    Public Const E1CFG_RETENTION_TIMEOUT As Short = 1
    Public Const E1CFG_ANSWER_TIMEOUT As Short = 2
    Public Const E1CFG_BLOCKING_ON As Short = 3
    Public Const E1CFG_BLOCKING_OFF As Short = 4
    Public Const E1CFG_MFT_TIMEOUT As Short = 5
    Public Const E1CFG_MFF_TIMEOUT As Short = 6
    Public Const E1CFG_MAXDIGITS_RX As Short = 7
    Public Const E1CFG_SEND_ID_AFTERDIGIT As Short = 8
    Public Const E1CFG_GROUP_B As Short = 9
    Public Const E1CFG_GROUP_II As Short = 10
    Public Const SILENCE_THRESHOLD As Short = 11
    Public Const SILENCE_THRESHOLD_AFTER As Short = 12
    Public Const E1CFG_GENERATE_RINGBACK As Short = 13
    Public Const E1CFG_R2_COUNTRY As Short = 14
    Public Const E1CFG_SIGTYPE As Short = 15
    Public Const E1CFG_MAX As Short = 16

    'CONSTANTS of COMMANDS IN DG_CONFIG_GSM_HANDLE
    Public Const REC_UNREAD As Short = 0
    Public Const REC_READ As Short = 1
    Public Const STO_UNSENT As Short = 2
    Public Const STO_SENT As Short = 3
    Public Const ALL As Short = 4

    Public Const GSM_RELEASE_CALLS As Short = 0
    Public Const GSM_TERMINATE_AND_ACCEPT As Short = 1
    Public Const GSM_PUT_ON_HOLD As Short = 2
    Public Const GSM_CONFERENCE As Short = 3


    Public Const GSM_AT_IDLE As Short = 1
    Public Const GSM_AT_RECEIVING As Short = 2
    Public Const GSM_IDLE As Short = 3
    Public Const GSM_EF As Short = 4
    Public Const GSM_E0 As Short = 5
    Public Const GSM_IPR As Short = 6
    Public Const GSM_CPIN As Short = 7
    Public Const GSM_COPS As Short = 8
    Public Const GSM_SNFS As Short = 9
    Public Const GSM_SAIC As Short = 10
    Public Const GSM_CLIP As Short = 11
    Public Const GSM_CMEE As Short = 12
    Public Const GSM_CLIR As Short = 13
    Public Const GSM_CSCS As Short = 14
    Public Const GSM_CSMS As Short = 15
    Public Const GSM_CNMI As Short = 16
    Public Const GSM_SMGO As Short = 17
    Public Const GSM_CPMS As Short = 18
    Public Const GSM_CMGF As Short = 19
    Public Const GSM_Q3 As Short = 20
    Public Const GSM_ALL As Short = 21
    Public Const GSM_SMS1 As Short = 22
    Public Const GSM_SMS2 As Short = 23
    Public Const GSM_SMS3 As Short = 24
    Public Const GSM_SYSSTART As Short = 25
    Public Const GSM_SIM_PIN As Short = 26
    Public Const GSM_SIM_PUK As Short = 27
    Public Const GSM_SIM_PIN2 As Short = 28
    Public Const GSM_SIM_PUK2 As Short = 29
    Public Const GSM_PHSIM_PIN As Short = 30
    Public Const GSM_PHSIM_PUK As Short = 31
    Public Const GSM_PHFSIM_PIN As Short = 32
    Public Const GSM_PHFSIM_PUK As Short = 33
    Public Const GSM_PHNET_PUK As Short = 34
    Public Const GSM_PHNS_PIN As Short = 35
    Public Const GSM_PHNS_PUK As Short = 36
    Public Const GSM_PHSP_PIN As Short = 37
    Public Const GSM_PHSP_PUK As Short = 38
    Public Const GSM_PHC_PIN As Short = 39
    Public Const GSM_PHC_PUK As Short = 40
    Public Const GSM_CLEAR As Short = 41
    Public Const GSM_CLEAR0 As Short = 42
    Public Const GSM_LIST As Short = 43
    Public Const GSM_SNFPT As Short = 44
    Public Const GSM_CCWA As Short = 45
    Public Const GSM_CUSD As Short = 46


    'constants for gsm sms listing command
    Public Const GSMCFG_DIGIT_TIMEOUT As Short = 0
    Public Const GSMCFG_ID_RESTRICTION As Short = 1
    Public Const GSMCFG_USSD_ENABLE As Short = 2
    Public Const GSMCFG_CALL_WAITING_ENABLE As Short = 3
    Public Const GSMCFG_RETRY_TIMEOUT As Short = 4
    Public Const GSMCFG_ANSWER_TIMEOUT As Short = 5
    Public Const GSMCFG_MAX As Short = 6


    'CONSTANTS OF COMMANDS IN DG_CONFIG_CUSTOMCAS
    Public Const CASCFG_RING As Short = 0
    Public Const CASCFG_CALLER_HANGUP As Short = 1
    Public Const CASCFG_IDLE As Short = 2
    Public Const CASCFG_ANSWER As Short = 3
    Public Const CASCFG_PICKUP As Short = 4
    Public Const CASCFG_DROP_DELAY_BEFORE As Short = 5
    Public Const CASCFG_DROP As Short = 6
    Public Const CASCFG_FLASH1_CMD As Short = 7
    Public Const CASCFG_FLASH1_DELAY As Short = 8
    Public Const CASCFG_FLASH2_CMD As Short = 9
    Public Const CASCFG_FLASH2_DELAY As Short = 10


    'constants to configure call progress behaviour
    Public Const CPCFG_ANSWER_SENSITIVITY As Short = 0
    Public Const CPCFG_ANSWER_SENSITIVITY_TIME As Short = 1
    Public Const CPCFG_GENERICTONETIMEOUT As Short = 2
    Public Const CPCFG_GENERICTONETIME As Short = 3
    Public Const CPCFG_LINETONETIMEOUT As Short = 4
    Public Const CPCFG_LINETONETIME As Short = 5
    Public Const CPCFG_FAXTONETIMEOUT As Short = 6
    Public Const CPCFG_FAXTONETIME As Short = 7
    Public Const CPCFG_CALLPROGRESSTIMEOUT As Short = 8
    Public Const CPCFG_BUSYMINTIME As Short = 9
    Public Const CPCFG_BUSYMAXTIME As Short = 10
    Public Const CPCFG_CALLINGMINTONETIME As Short = 11
    Public Const CPCFG_CALLINGMAXTONETIME As Short = 12
    Public Const CPCFG_CALLINGMINSILTIME As Short = 13
    Public Const CPCFG_CALLINGMAXSILTIME As Short = 14
    Public Const CPCFG_TONEINTERRUPTIONMINTIME As Short = 15
    Public Const CPCFG_TONEINTERRUPTIONMAXTIME As Short = 16
    Public Const CPCFG_LINETONEMINTIME As Short = 17
    Public Const CPCFG_LINETONEMAXTIME As Short = 18
    Public Const CPCFG_LINEFREQ As Short = 19              '---- FREQUENCIES
    Public Const CPCFG_CALLINGFREQ As Short = 20
    Public Const CPCFG_BUSYFREQ As Short = 21
    Public Const CPCFG_GENERICFREQ As Short = 22
    Public Const CPCFG_SILENCE As Short = 23
    Public Const CPCFG_AUDIO As Short = 24
    Public Const CPCFG_FAX1 As Short = 25
    Public Const CPCFG_FAX2 As Short = 26
    Public Const CPCFG_BUSYSENSIBILITY As Short = 27
    Public Const CPCFG_MAX As Short = 999


    Public Const DG_DIGITAL_INTERFACE As Short = 1
    Public Const DG_FXO_INTERFACE As Short = 2
    Public Const DG_FX_INTERFACE As Short = 3
    Public Const DG_GSM_INTERFACE As Short = 4
    Public Const DG_FXS_INTERFACE As Short = 5
    Public Const DG_UNKNOWN_INTERFACE As Short = 99


    Public Const DG_FX_TYPE_NONE As Short = 0
    Public Const DG_FX_TYPE_FXS As Short = 1
    Public Const DG_FX_TYPE_FXO As Short = 2
    Public Const DG_FX_TYPE_FXO2 As Short = 3

    'constants to use in OnLoggerEvent
    Public Const LOGGER_FREE_WITH_BILLING As Short = 1
    Public Const LOGGER_BUSY As Short = 2
    Public Const LOGGER_NUMBER_CHANGED As Short = 3
    Public Const LOGGER_CONGESTION As Short = 4
    Public Const LOGGER_FREE_WITHOUT_BILLING As Short = 5
    Public Const LOGGER_FREE_RETENTION As Short = 6
    Public Const LOGGER_LEVEL_NUMBER_AVAILABLE As Short = 7
    Public Const LOGGER_RESERVED_8 As Short = 8
    Public Const LOGGER_RESERVED_9 As Short = 9
    Public Const LOGGER_RESERVED_10 As Short = 10
    Public Const LOGGER_RESERVED_11 As Short = 11
    Public Const LOGGER_RESERVED_12 As Short = 12
    Public Const LOGGER_RESERVED_13 As Short = 13
    Public Const LOGGER_RESERVED_14 As Short = 14
    Public Const LOGGER_RESERVED_15 As Short = 15
    Public Const LOGGER_B_ENDCALL As Short = 20
    Public Const LOGGER_B_RETURN As Short = 21
    Public Const LOGGER_LINEREADY As Short = 22
    Public Const LOGGER_LINEOFF As Short = 23
    Public Const LOGGER_R2DMF As Short = 100



    Public Const AGC_TYPE_LOGGER As Short = 1
    Public Const AGC_TYPE_CONFERENCE As Short = 2


    'identification for alarms
    Public Const ALARM_RSLIP As Short = &H1       'escorregamento
    Public Const ALARM_RAIS As Short = &H2        'alarme remoto
    Public Const ALARM_AISS As Short = &H4        'indicacao de alarme
    Public Const ALARM_AIS16S As Short = &H8      'indicacao de alarme canal  16
    Public Const ALARM_LOSS As Short = &H10       'perda de sinal
    Public Const ALARM_CRC4SYNC As Short = &H20   'reservado
    Public Const ALARM_MFSYNC As Short = &H40     'sincronismo de multiquadro
    Public Const ALARM_SYNC As Short = &H80       'sincronismo de quadro


    'conference directions to enable command
    Public Const CHAT_LISTEN As Short = 0
    Public Const CHAT_TALK As Short = 1
    Public Const CHAT_TALK_LISTEN As Short = 2


    'commands to enable call progress
    Public Const CP_ENABLE_ALL As Short = 1
    Public Const CP_ENABLE_GENERIC_TONE As Short = 2
    Public Const CP_ENABLE_LINETONE_OR_BUSY As Short = 3
    Public Const CP_ENABLE_BUSY_OR_FAX As Short = 4
    Public Const CP_DISABLE As Short = 5
    Public Const CP_MAX As Short = 6

    '/* r2 country definitions */
    Public Const R2_COUNTRY_BR As Short = 1
    Public Const R2_COUNTRY_AR As Short = 2
    Public Const R2_COUNTRY_MX As Short = 3

    '/* r2 type/signalling definitions */
    Public Const R2_TYPE_MFC As Short = 1
    Public Const R2_TYPE_CB_FXO As Short = 2
    Public Const R2_TYPE_CB_FXS As Short = 3



    Public Const NOT_A_VALID_FILE As Short = 1
    Public Const RIFF_NOT_FOUND As Short = 2
    Public Const WAVE_NOT_FOUND As Short = 3
    Public Const FMT_NOT_FOUND As Short = 4
    Public Const FACT_NOT_FOUND As Short = 5
    Public Const DATA_NOT_FOUND As Short = 6

    'File Format
    Public Const ffWaveULaw As Short = 0
    Public Const ffSig As Short = 1
    Public Const ffWavePCM As Short = 2
    Public Const ffGsm610 As Short = 3
    Public Const ffWaveALaw As Short = 4
    Public Const ffWave49 As Short = 5

    Public Const DETECT_OFF As Short = &H0
    Public Const DETECT_DTMF As Short = &H1
    Public Const DETECT_MFT As Short = &H2
    Public Const DETECT_MFF As Short = &H4
    Public Const DETECT_MF As Short = &H8
    Public Const DETECT_TONE1 As Short = &H10
    Public Const DETECT_TONE2 As Short = &H20
    Public Const DETECT_TONE3 As Short = &H40
    Public Const DETECT_TONE4 As Short = &H80
    Public Const DETECT_AUDIO As Short = &H100
    Public Const DETECT_TONE5 As Short = &H200
    Public Const DETECT_TONE6 As Short = &H400
    Public Const DETECT_TONE7 As Short = &H800
    Public Const DETECT_TONE8 As Short = &H1000
    Public Const DETECT_ALL_MF As Short = &H7000
    Public Const DETECT_ALL_TONE As Short = &H7001
    Public Const DG_ENABLE As Short = 1
    Public Const DG_DISABLE As Short = 0

    Public Const ptFile As Short = &H0
    Public Const ptCurrency As Short = &H1
    Public Const ptDate As Short = &H2
    Public Const ptTime As Short = &H3
    Public Const ptCardinal As Short = &H4
    Public Const ptNumber As Short = &H5

    Public Const mpAborted As Short = 0
    Public Const mpRetriesExceeded As Short = 1
    Public Const mpOk As Short = 2
    Public Const mpCanceled As Short = 3

    Public Const VBE13060PCI As Short = 16448   ' Placa E1 3060 PCI
    Public Const VB0408PCI As Short = 16904     ' Placa FXO de 4/8 canais
    Public Const VBE13060PCI_R As Short = 17472 ' Placa E1 3060 PCI com revisao
    Public Const VBE16060PCI As Short = 17984   ' Placa E1 60 canais PCI
    Public Const VBE16060PCI_R As Short = 18432 ' Placa E1 60 canais PCI com revisao
    Public Const VBE13030PCI As Short = 18944   ' Placa E1 30 canais PCI
    Public Const VB0404FX_R As Short = 19480    ' Placa FXS de 4 canais com revisao 
    Public Const VB6060PCIE As Short = 19969    ' Placa E1 60 canais PCI Express
    Public Const VB3030PCIE As Short = 20481    ' Placa E1 30 canais PCI Express
    Public Const VB0404GSM As Short = 21152     ' Placa GSM de 2/4 canais
    Public Const VB1224PCIE As Short = 21706    ' Placa para gravacao
    Public Const VB0404FX As Short = 22032      ' Placa FXS de 4 canais
    Public Const VB0408PCIE As Short = 22537    ' Placa FXO de 4/8 canais Express
    Public Const VB1200PCIE As Short = 23041    ' Placa E1 de 120 canais PCI Express

    Public Const DG_SILENCE_DETECTED As Short = 1

    'Resultado do retorno e.state do evento OnE1StateChange
    Public Const C_GRUPO_B As Short = 4101                  '(0x1005) - Solicita grupo B para aplicacao
    Public Const C_NOTCOMPLETED As Short = 4117             '(0x1015) - Ligaco nao completada
    Public Const C_B_ENDCALL As Short = 4116                '(0x1014) - Assinante B desligou
    Public Const C_ANSWERED As Short = 4114                 '(0x1012) - Assinante B atendeu ou retornou depois de C_B_ENDCALL
    Public Const C_CONGESTION As Short = 4115               '(0x1013) - Congestionamento
    Public Const C_SEIZURE As Short = 4107                  '(0x100b) - Ocupacao
    Public Const C_GROUP_II As Short = 4119                 '(0x1017) - Grupo II recebido
    Public Const C_NUMBER_RECEIVED As Short = 4109          '(0x100d) - Numero recebido durante ligacao(entrante)
    Public Const C_UNAVAILABLE As Short = 4113              '(0x1011) - Canal nao disponivel
    Public Const C_GROUP_I As Short = 4124                  '(0x101c) - Recebeu grupo I
    Public Const C_ID_RECEIVED As Short = 4106              '(0x100a) - Recebeu identificao de assinante         A()
    Public Const C_E1_IDLE As Short = 4138                  '(0x102a) - Canal R2 foi para o estado LIVRE
    Public Const C_E1_SEIZURE_ACK As Short = 4141           '(0x102d) - Canal R2 recebeu confirmacao de(ocupacao)
    Public Const C_SEND_GROUP_B As Short = 4142             '(0x102e) - Recebeu Grupo B da aplicacao
    Public Const C_SEND_BACKWARD_SIGNAL As Short = 4143     '(0x102f) - Recebeu comando de envio de sinal "para tras" da aplicacao

    'silence detection state constants
    Public Const SILENCE_OFF As Short = 0
    Public Const SILENCE_ON As Short = 1

    'C_ERROR Codes
    Public Const ERROR_FIFO_FULL As Short = &H79
    Public Const ERROR_READ_FAILURE As Short = &H80
    Public Const ERROR_CARD_RESET As Short = &H99
    Public Const ERROR_CMD_OVERFLOW As Short = &H98

    Public Const CP_SILENCE As Short = &H20
    Public Const CP_AUDIO As Short = &H21
    Public Const CP_TONE1 As Short = &H22
    Public Const CP_TONE2 As Short = &H23
    Public Const CP_TONE3 As Short = &H24
    Public Const CP_TONE4 As Short = &H25
    Public Const CP_TONE5 As Short = &H26
    Public Const CP_TONE6 As Short = &H27
    Public Const CP_TONE7 As Short = &H28
    Public Const CP_TONE8 As Short = &H29
    Public Const CP_UNDEFINED As Short = &H40
    Public Const CP_INVALID As Short = &H41

    'cmd_detecta_cfg configuration
    Public Const CFG_DETECT_SILENCE As Short = 0
    Public Const CFG_DETECT_FREQDTMF As Short = 1
    Public Const CFG_DETECT_FREQMFT As Short = 2
    Public Const CFG_DETECT_FREQMFF As Short = 3
    Public Const CFG_DETECT_FREQMF As Short = 4
    Public Const CFG_DETECT_FREQTONE1 As Short = 5
    Public Const CFG_DETECT_FREQTONE2 As Short = 6
    Public Const CFG_DETECT_FREQTONE3 As Short = 7
    Public Const CFG_DETECT_FREQTONE4 As Short = 8
    Public Const CFG_DETECT_FREQTONE5 As Short = 9
    Public Const CFG_DETECT_FREQTONE6 As Short = 10
    Public Const CFG_DETECT_FREQTONE7 As Short = 11
    Public Const CFG_DETECT_FREQTONE8 As Short = 12
    
    'eventos para o host
    Public Const C_ERROR As Short = &H43
    Public Const C_CAS As Short = 1
    Public Const C_AUDIO As Short = 2
    Public Const C_FRAMER As Short = 3
    Public Const C_ALARM As Short = 4
    Public Const C_PULSE As Short = 5
    Public Const C_CTBUS As Short = 6
    Public Const C_LINESTATE As Short = 7
    Public Const C_ALARME_H100 As Short = &H8
    Public Const C_UART1 As Short = &H10
    Public Const C_UART2 As Short = &H11
    Public Const C_SENDSMS As Short = &H12
    Public Const C_UART3 As Short = &H13

    'framer looping types
    Public Const FRAMER_LOOP_OFF As Short = 0
    Public Const FRAMER_LOOP_REMOTE As Short = 1
    Public Const FRAMER_LOOP_LOCAL As Short = 2
    
    'framer looping types
    Public Const E1_A As Short = 1
    Public Const E1_B As Short = 2

    'array for call progress detections
    Public Const T_AUDIO As Short = 0
    Public Const T_LINE As Short = 1
    Public Const T_CALLING As Short = 2
    Public Const T_BUSY As Short = 3
    Public Const T_FAX1 As Short = 4
    Public Const T_FAX2 As Short = 5
    Public Const T_GTONE As Short = 6
    Public Const T_GTONE2 As Short = 7
    Public Const T_GTONE3 As Short = 8
    Public Const T_GTONE4 As Short = 9
    Public Const T_GTONE5 As Short = 10
    Public Const T_SILENCE As Short = 11
    Public Const T_OPINC As Short = 12

    'config do sincronismo (CMD_H100_CFG)
    Public Const SYNC_LINE_A As Short = 1
    Public Const SYNC_LINE_B As Short = 2
    Public Const SYNC_INTERNAL As Short = 3
    Public Const SYNC_H100_CT_A As Short = 4
    Public Const SYNC_H100_CT_B As Short = 5
    Public Const SYNC_H100_SCBUS_2048 As Short = 6
    Public Const SYNC_H100_SCBUS_4096 As Short = 7
    Public Const SYNC_H100_SCBUS_8192 As Short = 8
    Public Const SYNC_H100_MVIP As Short = 9
    Public Const SYNC_H100_H_MVIP As Short = 10
    Public Const SYNC_H100_CT_NETREF As Short = 11
    Public Const SYNC_H100_CLK_LINE_A As Short = 12
    Public Const SYNC_H100_CLK_LINE_B As Short = 13
    Public Const SYNC_H100_INTERNAL As Short = 14

    'constantes para manter compatibilidade com placa antiga
    Public Const MASTER_INTERNAL_SYNC As Short = 3
    Public Const MASTER_SYNC_A As Short = 1
    Public Const MASTER_SYNC_B As Short = 2
    Public Const SLAVE_MODE As Short = 4

    Public Const TX_GAIN As Short = 0
    Public Const RX_GAIN As Short = 1
    Public Const REC_GAIN As Short = 2
    Public Const PLAY_GAINA As Short = 3

    'gsm mode
    Public Const GSM_DIGIVOICE As Short = 0
    Public Const GSM_RAW As Short = 1

    Public Const AUDIO_DETECTED As Short = 0
    Public Const TIMEOUT_DETECTED As Short = 1

    'silence detection constants
    Public Const DG_AUDIO_DETECTED As Short = 0

    Public Const ALARM_GETSTATUS As Short = 0
    Public Const ALARM_MANUAL_NOTIFY As Short = 1
    Public Const ALARM_AUTOMATIC_NOTIFY As Short = 2

    Public Const mkOK As Short = 0
    Public Const mkNoDialTone As Short = 1
    Public Const mkDelivered As Short = 2
    Public Const mkNoAnswer As Short = 3
    Public Const mkBusy As Short = 4
    Public Const mkAnswered As Short = 5
    Public Const mkAborted As Short = 6
    Public Const mkDialToneAfterDial As Short = 7
    Public Const mkFaxDetected As Short = 8

    Public Const csPlayingStartPhrase As Short = 0
    Public Const csPickingUp As Short = 1
    Public Const csInitialFlash As Short = 2
    Public Const csDialingPrefix As Short = 3
    Public Const csStartAnalysis As Short = 4
    Public Const csNoAnswerReturn As Short = 5
    Public Const csPlayingBusyPhrase As Short = 6
    Public Const csPlayingNoAnswerPhrase As Short = 7
    Public Const csWaitingDialTone As Short = 8
    Public Const csDialing As Short = 9
    Public Const csCalling As Short = 10


    'Sinalizacao R2 digital */
    Public Const R2_IDLE As Short = &H9
    Public Const R2_CLEAR_FOWARD As Short = &H9
    Public Const R2_SEIZURE As Short = &H1
    Public Const R2_BACKWARD_DISCONNECTION As Short = &H1
    Public Const R2_SEIZURE_ACK As Short = &HD
    Public Const R2_BILLING As Short = &HD
    Public Const R2_CLEAR_BACK As Short = &HD
    Public Const R2_ANSWERED As Short = &H5
    Public Const R2_BLOCKED As Short = &HD
    Public Const R2_FAILURE As Short = &HD
    Public Const R2_ENABLEDETECTION As Short = &H10
    Public Const R2_DISABLEDETECTION As Short = &H20

    Public Const wtDTMF As Short     = 0
    Public Const wtMFP As Short      = 1
    Public Const wtCustom As Short   = 2

   Public Const  INCOMINGCALL As Short = 1
   Public Const	 OUTGOINGCALL As Short = 2
   
   Public Const ctExternal As Short = 0
   Public Const	ctWithFlash As Short = 1

   Public Const msAborted As Short   = 0
   Public Const msTimeOut As Short   = 1
   Public Const msRetriesExceeded As Short = 2
   Public Const msValidOptionDetected As Short =3

   Public Const	GENERATE_OFF As Short    = 0
   Public Const	GENERATE_DTMF As Short   = 1
   Public Const	GENERATE_MFT As Short    = 2
   Public Const	GENERATE_MFF As Short    = 3
   Public Const	GENERATE_MF As Short     = 4
   Public Const	GENERATE_TONE1 As Short  = 5
   Public Const	GENERATE_TONE2 As Short  = 6

End Class
