﻿Option Explicit On

Imports WAVlib0408.Constantes
Imports WAVlib0408.Module1
Imports System.Runtime.InteropServices
Imports System.IO
Imports System.AppDomain

Public Class Form1
    Public nPortaEmUso As Short
    Public nCanalInicial As Short
    Public nCanalFinal As Short
    Public nContaRing As Short
    Public nDirAtual As String = CurrentDomain.BaseDirectory

    Public Function HabilitaTelaStartVoicerLib() As Integer

        btnIniciaDriver.Enabled = False
        btnFinalizaDriver.Enabled = True
        btnMostraVersao.Enabled = True
        btnAplicar.Enabled = True

        gpbComandosGerais.Enabled = True
        gpbPropriedadesEspeciais.Enabled = True
        gpbComandosDeAudio.Enabled = True
        gpbReproduzir.Enabled = True
        gpbLogDeEventos.Enabled = True
        gpbDetAtendimento.Enabled = False
        gpbDetPulso.Enabled = True

        txtNumero.Text = ""
        txtTempoFlash.Text = "150"

        rbDTMF.Checked = True
        rbOFFDetPulso.Checked = True
        rbONDetecAtend.Checked = True

        txtSensPulso.Text = "5"
        txtLimiarSilencio.Text = "-30"
        txtFreqTons.Text = "425"
        txtArquivoDeAudio.Text = "C:\teste.wav"
        txtDigitoTerminador.Text = ""
        txtGanhoGravacao.Text = "4"
        txtReproduzir.Text = "1234,56"

        If Directory.Exists("C:\Arquivos de Programas") Then
            txtCaminhoStockSigs.Text = "C:\Arquivos de Programas\VoicerLib4\StockSigs"
        Else
            If Directory.Exists("C:\Program Files") Then
                txtCaminhoStockSigs.Text = "C:\Program Files\VoicerLib4\StockSigs"
            End If
        End If

        cbFormatoAudio.SelectedIndex = 0
        'cbArquivoCP.SelectedIndex = 0
        If cbArquivoCP.Text = "" Then
            cbArquivoCP.Text = "cp_default.cfg"
        End If

        txtArquivoDeAudio.Text = nDirAtual & "teste.wav"
    End Function
    Public Function DesabilitaTelaShutDown() As Integer

        lblCanalInicial.Text = ""
        lblCanalFinal.Text = ""

        txtCaminhoStockSigs.Text = ""
        txtNumero.Text = ""
        txtArquivoDeAudio.Text = ""

        cbArquivoCP.Text = ""
        cbFormatoAudio.Text = ""

        chkHabilitaFSK.Checked = False
        chkMostraEvAudio.Checked = False

        btnIniciaDriver.Enabled = True
        btnFinalizaDriver.Enabled = False
        btnMostraVersao.Enabled = False
        btnAplicar.Enabled = False

        gpbComandosGerais.Enabled = False
        gpbPropriedadesEspeciais.Enabled = False
        gpbComandosDeAudio.Enabled = False
        gpbReproduzir.Enabled = False
        gpbLogDeEventos.Enabled = True
        gpbDetPulso.Enabled = False

        rbDTMF.Checked = False
        rbMFC.Checked = False
        rbOFFDetecAtend.Checked = False
        rbOFFDetPulso.Checked = False
        rbONDetecAtend.Checked = False
        rbONDetPulso.Checked = False

    End Function
    'Esta funcao habilita a deteccao de callprogress (EnableCallProgress)
    'de acordo com o tipo passado. Cada tipo deve ser utilizado em situacoes
    'especificas - consulte o manual
    Public Function HabilitaSupervisaoGlobal(ByVal nPorta As Integer, ByVal nTipoSupervisao As Integer) As Short
        Dim nRet As Short

        nRet = vlib.DisableCallProgress(nPorta)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPorta, "Erro ao desabilitar supervisão de linha.nRet " & nRet.ToString())
        End If
        nRet = vlib.EnableCallProgress(nPorta, CP_ENABLE_ALL)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPorta, "Erro ao habilitar supervisão de linha ALL.nRet " & nRet.ToString())
        Else
            MostraStatus(nPorta, "Supervisão de linha ALL habilitada com sucesso!")
        End If

        Return nRet

    End Function

    Private Sub btnIniciaDriver_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIniciaDriver.Click
        Dim nRet As Short
        Dim nForCanal As Short
        Dim nForPlaca As Short
        Dim nCanalCorrente As Short
        Dim sInfo As String = " "

        'aloca espaco de 100 bytes para string
        Dim ptr As IntPtr = System.Runtime.InteropServices.Marshal.AllocHGlobal(300)

        'Determina o caminho de configuracao para a placa 
        If Directory.Exists("\Arquivos de Programas") Then
            vlib.ConfigPath = "C:\Arquivos de Programas\VoicerLib4"
        Else
            If Directory.Exists("\Program Files") Then
                vlib.ConfigPath = "C:\Program Files\VoicerLib4"
            End If
        End If

        'Inicia a voicerlib
        nRet = vlib.StartVoicerLib()
        'Testa o retorno do StartVoicerLib
        MostraStatus(0, nRet, "Inicializacao da Voicerlib ")
        MostraStatus(0, vlib.CardsCount.ToString() & " placa(s) detectada(s)")

        If nRet = DG_EXIT_SUCCESS Then
            txtCanal.Maximum = vlib.GetPortsCount.ToString()
            nCanalInicial = 1
            nCanalFinal = 0
            nCanalCorrente = 0

            For nForCanal = 1 To vlib.GetPortsCount
                nCanalCorrente = nForCanal

                nRet = vlib.IdleSettings(nForCanal, False, 0, 0, True, True, wtDTMF, 5000, 20, "C")
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao configurar o IdleSettings.nRet " & nRet.ToString())
                End If

                nRet = vlib.IdleStart(nForCanal)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao executar o IdleStart.nRet " & nRet.ToString())
                End If

                If ((vlib.GetPortCardType(nForCanal) = VB0408PCI) Or (vlib.GetPortCardType(nForCanal) = VB0408PCIE)) Then
                    'If nCanalInicial = 0 Then
                    'nCanalInicial = nCanalCorrente
                    lblCanalInicial.Text = "Primeiro Canal da Placa VB0408PCI/PCIe = " & nCanalInicial.ToString()
                    'End If
                Else
                    If (nCanalInicial <> 0) And (nCanalFinal = 0) Then
                        nCanalFinal = nCanalCorrente - 1
                        lblCanalFinal.Text = "Último Canal da Placa VB0408PCI/PCIe = " & nCanalFinal.ToString()
                    End If
                End If

            Next

            If nCanalFinal = 0 Then
                nCanalFinal = nCanalCorrente
                lblCanalFinal.Text = "Último Canal da Placa VB0408PCI/PCIe = " & nCanalFinal.ToString()
            End If

            txtCanal.Text = nCanalInicial.ToString()
            txtCanal.Minimum = nCanalInicial.ToString()
            txtCanal.Maximum = nCanalFinal.ToString()
            nPortaEmUso = nCanalInicial

            HabilitaTelaStartVoicerLib()

            For nForCanal = nCanalInicial To nCanalFinal

                nRet = vlib.CreateCallProgress(nForCanal, cbArquivoCP.Text)
                If nRet <> DG_EXIT_SUCCESS Then
                    If nRet = DG_WARNING_OLDFILEFORMAT Then
                        MostraStatus(nForCanal, "ATENCAO: O arquivo de configuração " & cbArquivoCP.Text & " está desatualizado e pode causar mal funcionamento do callprogress. nRet: " & nRet.ToString())
                    Else
                        MostraStatus(nForCanal, "Erro ao criar supervisão de linha.nRet " & nRet.ToString())
                    End If
                Else
                    MostraStatus(nForCanal, "Supervisão de linha 'criada' com sucesso usando " & cbArquivoCP.Text)
                    gpbDetAtendimento.Enabled = True
                End If

                'Detecta Tons DTMF
                nRet = vlib.SetDetectionType(nForCanal, DETECT_MFF, DG_DISABLE)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao desabilitar detecção de MF.nRet " & nRet.ToString())
                End If

                nRet = vlib.SetDetectionType(nForCanal, DETECT_DTMF, DG_ENABLE)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao habilitar detecção de DTMF.nRet " & nRet.ToString())
                End If

                'Configura Limiar para detectar Atendimento
                nRet = vlib.SetSilenceThreshold(nForCanal, Convert.ToInt16(txtLimiarSilencio.Text))
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao setar limiar para detecção de atendimento.nRet " & nRet.ToString())
                End If
            Next

            'Define frequencia padrao
            For nForPlaca = 1 To vlib.GetCardsCount
                If ((vlib.GetCardType(nForPlaca) = VB0408PCI) Or (vlib.GetCardType(nForPlaca) = VB0408PCIE)) Then
                    nRet = vlib.SetCardDetections(nForPlaca, CFG_DETECT_FREQTONE1, Convert.ToInt16(txtFreqTons.Text), 0)
                    If nRet <> DG_EXIT_SUCCESS Then
                        MostraStatus(nForPlaca, "Erro ao modificar a frequência de supervisão.nRet " & nRet.ToString())
                    End If
                End If
                vlib.GetCardInfo(nForPlaca, ptr)
                sInfo = System.Runtime.InteropServices.Marshal.PtrToStringAnsi(ptr)
                MostraStatus(nForPlaca, "Info:" & sInfo)
            Next

            If ckMonitorarAudio.Checked Then
                'Desabilita input buffer
                nRet = vlib.DisableInputBuffer(Convert.ToInt16(txtCanal.Text))
                If ((nRet <> DG_EXIT_SUCCESS) And (nRet <> DG_ERROR_THREAD_ALREADY_RUNNING)) Then
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao desabilitar input buffer.nRet " & nRet.ToString())
                Else
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Desabilitou InputBuffer")
                End If
                'Habilita input buffer
                nRet = vlib.EnableInputBuffer(Convert.ToInt16(txtCanal.Text), DG_ENABLE_AGC)
                If ((nRet <> DG_EXIT_SUCCESS) And (nRet <> DG_ERROR_THREAD_ALREADY_RUNNING)) Then
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao habilitar input buffer.nRet " & nRet.ToString())
                Else
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Habilitou input buffer")
                End If

                'Liga a monitoracao do audio
                nRet = vlib.AudioMonitor(Convert.ToInt16(txtCanal.Text), DG_ENABLE)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao habilitar monitoração do audio.nRet " & nRet.ToString())
                End If
            End If
        End If

        'libera memoria alocada
        System.Runtime.InteropServices.Marshal.FreeHGlobal(ptr)

    End Sub

    Private Sub btnFinalizaDriver_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFinalizaDriver.Click
        Dim nRet As Short
        Dim nForCanal As Short

        DesabilitaTelaShutDown()

        If vlib.DriverEnabled Then

            For nForCanal = nCanalInicial To nCanalFinal

                nRet = vlib.HangUp(nForCanal)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao desligar a porta.nRet " & nRet.ToString())
                End If

                nRet = vlib.DisableInputBuffer(nForCanal)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao desabilitar input buffer.nRet " & nRet.ToString())
                Else
                    MostraStatus(nForCanal, "Desabilitou o input buffer")
                End If

                nRet = vlib.DisableCallProgress(nForCanal)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao desabilitar CallProgress.nRet " & nRet.ToString())
                End If

                nRet = vlib.IdleAbort(nForCanal)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao desabilitar o Idle Abort.nRet " & nRet.ToString())
                End If

                nRet = vlib.DestroyCallProgress(nForCanal)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao destruir CallProgress.nRet " & nRet.ToString())
                End If
            Next
        End If

        'Finaliza a VoicerLib
        nRet = vlib.ShutdownVoicerLib
        If nRet <> DG_EXIT_SUCCESS Then
            MsgBox("Não foi possível finalizar a VoicerLib.nRet " & nRet.ToString())
        Else
            MostraStatus(0, "Voicerlib finalizada com sucesso!")
        End If
    End Sub

    Private Sub btnMostraVersao_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMostraVersao.Click
        Dim i As Integer

        If vlib.DriverEnabled Then
            For i = 1 To vlib.GetCardsCount
                MostraStatus(i, "Placa " & i.ToString() & " Versão Firmware: " & Hex(vlib.GetVersion(i)) & "H")
            Next
        Else
            MostraStatus(0, "Para saber a versão é necessário inicializar o Driver. ")
        End If
    End Sub

    Private Sub btnAtende_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAtende.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then
            nRet = vlib.PickUp(nPortaEmUso, 0)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao atender.nRet " & nRet.ToString())
            Else
                MostraStatus(nPortaEmUso, "Atendeu com sucesso!")

                'Chama funcao que habilita o callprogress para esperar apenas
                'tom de linha ou ocupado
                HabilitaSupervisaoGlobal(nPortaEmUso, CP_ENABLE_LINETONE_OR_BUSY)
            End If
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub btnDesliga_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDesliga.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then
            nRet = vlib.HangUp(nPortaEmUso)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao desligar.nRet " & nRet.ToString())
            Else
                MostraStatus(nPortaEmUso, "Desligou com sucesso!")
            End If
            'Desabilita o callprogress da porta
            nRet = vlib.DisableCallProgress(nPortaEmUso)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao desabilitar a supervisão de linha.nRet " & nRet.ToString())
            End If
            nContaRing = 0

            vlib.GenerateMF(nPortaEmUso, GENERATE_OFF, 0)

        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub btnFlash_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFlash.Click
        Dim nRet As Short

        nRet = vlib.Flash(nPortaEmUso, Convert.ToInt16(txtTempoFlash.Text), 0)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, "Erro ao executar Flash.nRet " & nRet.ToString())
        Else
            MostraStatus(nPortaEmUso, "Flash executado com sucesso!")
        End If
    End Sub

    Private Sub btnGetDigits_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetDigits.Click
        Dim nRet As Short

        'Espera até 5 digitos ou finalizador #
        'Tempo maximo total - 15s
        'Tempo maximo entre os digitos - 5s
        vlib.ClearDigits(nPortaEmUso)

        nRet = vlib.GetDigits(nPortaEmUso, 5, "#", 15000, 5000)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, "Erro no GetDigits.nRet " & nRet.ToString())
        Else
            MostraStatus(nPortaEmUso, "Esperando Digitos...")
        End If
    End Sub

    Private Sub btnDiscar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDiscar.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then

            nRet = vlib.Dial(nPortaEmUso, txtNumero.Text, 0, dtTone)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao discar.nRet " & nRet.ToString)
            Else
                MostraStatus(nPortaEmUso, "Discou com sucesso: " & txtNumero.Text)
            End If
            'No evento AfterDial é habilitada a supervisao para depois da discagem
            'e espera de atendimento. A detecção de atendimento deve ser habilitada
            'manualmente pelo botão
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub btnFalar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFalar.Click
        Dim nRet As Short

        If ckMonitorarAudio.Checked = False Then
            'Desabilita o input buffer
            nRet = vlib.DisableInputBuffer(Convert.ToInt16(txtCanal.Text))
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao desabilitar o input buffer.nRet " & nRet.ToString())
            Else
                MostraStatus(Convert.ToInt16(txtCanal.Text), "Desabilitou o input buffer")
            End If
        End If

        'Indica o formato de reproducao
        Select Case cbFormatoAudio.SelectedIndex
            Case 0 'ffWaveULaw
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWaveULaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução.nRet " & nRet.ToString())
                End If

            Case 1 'ffWavePCM
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWavePCM)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução.nRet " & nRet.ToString())
                End If

            Case 2 'ffGsm610
                vlib.SetGSMMode(GSM_DIGIVOICE)
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução.nRet " & nRet.ToString())
                End If

            Case 3 'ffWaveALaw
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWaveALaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução.nRet " & nRet.ToString())
                End If

            Case 4 'ffWave49
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWave49)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reproducao.nRet " & nRet.ToString())
                End If

            Case 5 'ffGsmRaw
                vlib.SetGSMMode(GSM_RAW)
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução.nRet " & nRet.ToString())
                End If

        End Select

        'Inicia a reproducao de um arquivo atraves da placa
        nRet = vlib.PlayFile(nPortaEmUso, txtArquivoDeAudio.Text, txtDigitoTerminador.Text, 0)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, "Erro ao inicializar a reprodução.nRet " & nRet.ToString())
        Else
            MostraStatus(nPortaEmUso, "Reprodução inicializada com sucesso!")
        End If
    End Sub

    Private Sub btnPararReproducao_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPararReproducao.Click
        Dim nRet As Short

        If vlib.IsPlaying(Convert.ToInt16(txtCanal.Text)) Then
            'Interrompe a reproducao de um arquivo
            nRet = vlib.StopPlayFile(nPortaEmUso)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao interromper a reprodução.nRet " & nRet.ToString())
            Else
                MostraStatus(nPortaEmUso, "Reprodução interrompida com sucesso!")
            End If
        End If
    End Sub

    Private Sub btnFalaDinheiro_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFalaDinheiro.Click
        Dim nRet As Short

        If (vlib.DriverEnabled) Then
            If txtReproduzir.Text <> "" Then

                nRet = vlib.PlayCurrency(nPortaEmUso, txtReproduzir.Text, "#", 0)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao executar 'PlayCurrency'.nRet " & nRet.ToString())
                End If
            Else
                MostraStatus(nPortaEmUso, "ATENÇÃO: Você não informou nada a ser reproduzido")
            End If
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub btnFalaData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFalaData.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then
            If txtReproduzir.Text <> "" Then
                nRet = vlib.PlayDate(nPortaEmUso, txtReproduzir.Text, "d/m/y", "#", 0)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao executar 'PlayDate'.nRet " & nRet.ToString())
                End If
            Else
                MostraStatus(nPortaEmUso, "ATENÇÃO: Você não informou nada a ser reproduzido")
            End If
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub btnFalaCardinal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFalaCardinal.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then
            If txtReproduzir.Text <> "" Then
                nRet = vlib.PlayCardinal(nPortaEmUso, txtReproduzir.Text, "#", 500)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao executar 'PlayCardinal'.nRet " & nRet.ToString())
                End If
            Else
                MostraStatus(nPortaEmUso, "ATENÇÃO: Você não informou nada a ser reproduzido")
            End If
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub OnDetPulso_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbONDetPulso.CheckedChanged
        Dim nRet As Short
        Dim nForCanal As Short

        'Habilita a deteccao de pulso
        For nForCanal = nCanalInicial To nCanalFinal

            nRet = vlib.EnablePulseDetection(nForCanal, Convert.ToInt16(txtSensPulso.Text))
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nForCanal, "Erro ao habilitar detecção de pulso.nRet " & nRet.ToString())
            Else
                MostraStatus(nForCanal, "Deteccao de pulso habilitada com sucesso!")
            End If
        Next
    End Sub

    Private Sub rbOFFDetPulso_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbOFFDetPulso.CheckedChanged
        Dim nRet As Short
        Dim nForCanal As Short

        If vlib.DriverEnabled Then
            'Desabilita a deteccao de pulso
            For nForCanal = nCanalInicial To nCanalFinal
                nRet = vlib.DisablePulseDetection(nForCanal)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao desabilitar deteccao de pulso.nRet " & nRet.ToString())
                End If
            Next
        End If
    End Sub

    Private Sub btnFalaHora_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFalaHora.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then
            If txtReproduzir.Text <> " " Then
                nRet = vlib.PlayTime(nPortaEmUso, txtReproduzir.Text, "#", 0)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao executar 'PlayTime'.nRet " & nRet.ToString())
                End If
            Else
                MostraStatus(nPortaEmUso, "ATENÇÃO: Você não informou nada a ser reproduzido")
            End If
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub btnFalaNumero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFalaNumero.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then

            If txtReproduzir.Text <> "" Then

                nRet = vlib.PlayNumber(nPortaEmUso, txtReproduzir.Text, "#", 500)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao executar 'PlayNumber'.nRet " & nRet.ToString())
                End If
            Else
                MostraStatus(nPortaEmUso, "ATENÇÃO: Você não informou nada a ser reproduzido")
            End If
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub vlib_OnAfterDial(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnAfterDialEvent)
        Dim nRet As Short

        MostraStatus(e.port, "(OnAfterDial) -> Terminou de Discar")

        'Supervisao de linha que espera o tom de chamando (ringback), ocupado
        HabilitaSupervisaoGlobal(e.port, CP_ENABLE_ALL)

        If rbONDetecAtend.Checked Then
            nRet = vlib.EnableAnswerDetection(e.port)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(e.port, "(OnAfterDial) -> Erro ao habilitar supervisão de atendimento.nRet " & nRet.ToString())
            Else
                MostraStatus(e.port, "(OnAfterDial) -> Supervisão de atendimento habilitada com sucesso!")
            End If
        End If

    End Sub

    Private Sub vlib_OnAfterFlash(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnAfterFlashEvent)
        MostraStatus(e.port, "(OnAfterFlash) -> Terminou de Executar Flash")
    End Sub

    Private Sub vlib_OnAnswerDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnAnswerDetectedEvent)
        Dim nRet As Short

        Select Case e.answerType
            Case AUDIO_DETECTED
                MostraStatus(e.port, "(OnAnswerDetected) -> Detectou Atendimento por Presença de AUDIO")
            Case TIMEOUT_DETECTED
                MostraStatus(e.port, "(OnAnswerDetected) -> Detectou Atendimento por TIMEOUT")
        End Select

        'Supervisao de linha depois do atendimento que espera ocupado ou fax
        HabilitaSupervisaoGlobal(e.port, CP_ENABLE_BUSY_OR_FAX)

        If rbONDetecAtend.Checked Then
            nRet = vlib.DisableAnswerDetection(e.port)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(e.port, "(OnAnswerDetected) -> Erro ao desabilitar supervisão de atendimento.nRet " & nRet.ToString())
            Else
                MostraStatus(e.port, "(OnAnswerDetected) -> Supervisão de atendimento desabilitada!")
            End If
        End If

    End Sub

    Private Sub vlib_OnAudioSignalDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnAudioSignalDetectedEvent)
        If chkMostraEvAudio.Checked Then
            MostraStatus(e.port, "(OnAudioSignalDetected) -> Audio - " & Hex(e.signalCode))
        End If
    End Sub

    Private Sub vlib_OnBusyDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnBusyDetectedEvent)
        MostraStatus(e.port, "(OnBusyDetected) -> Sinal de Ocupado")
    End Sub

    Private Sub vlib_OnCallerID(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnCallerIDEvent)
        Dim sNome As String

        sNome = vlib.GetNameID(e.port)
        MostraStatus(e.port, "(OnCallerID) -> CallerID: " & e.number & " - Nome:" & sNome)
    End Sub
    'Ocorre quando a placa detecta tom chamada na linha.
    Private Sub vlib_OnCalling(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnCallingEvent)
        MostraStatus(e.port, "(OnCalling) -> Chamando")
    End Sub

    Private Sub vlib_OnDialToneDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnDialToneDetectedEvent)
        MostraStatus(e.port, "(OnDialToneDetected) -> Pronto para Discar")
    End Sub
    'Ocorre sempre que a placa detecta um digito.
    Private Sub vlib_OnDigitDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnDigitDetectedEvent)
        MostraStatus(e.port, "(OnDigitDetected) -> Recebeu Digito " & Chr(e.digit))
    End Sub

    Private Sub vlib_OnDigitsReceived(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnDigitsReceivedEvent)
        Select Case e.status
            Case edMaxDigits
                MostraStatus(e.port, "(OnDigitsReceived) -> Alcançou máximo de digitos: " & vlib.ReadDigits(e.port).ToString())
            Case edTermDigit
                MostraStatus(e.port, "(OnDigitsReceived) -> Recebeu digito finalizador: " & vlib.ReadDigits(e.port).ToString())
            Case edDigitTimeOut
                MostraStatus(e.port, "(OnDigitsReceived) -> Timeout global " & vlib.ReadDigits(e.port).ToString())
            Case edInterDigitTimeOut
                MostraStatus(e.port, "(OnDigitsReceived) -> Timeout interdigito: " & vlib.ReadDigits(e.port).ToString())
        End Select
        vlib.ClearDigits(e.port)
    End Sub

    Private Sub vlib_OnErrorDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnErrorDetectedEvent)
        MostraStatus(e.card, e.errorCode, "(OnErrorDetected) -> Erro código: ")
    End Sub
    'Ocorre quando um sinal de fax e' detectado pela placa.
    Private Sub vlib_OnFaxDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnFaxDetectedEvent)
        MostraStatus(e.port, "(OnFaxDetected) -> Detectou Fax")
    End Sub
    'Ocorre quando o usuario desliga o aparelho telefonico conectado a placa.
    Private Sub vlib_OnLineOff(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnLineOffEvent)
        MostraStatus(e.port, "(OnLineOff) -> Desligou o Fone (Aparelho)")
    End Sub

    Private Sub vlib_OnLineReady(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnLineReadyEvent)
        MostraStatus(e.port, "(OnLineReady) -> Pegou o Fone (Aparelho)")
    End Sub
    'Ocorre sempre quando for iniciado o playback de qualquer mensagem.
    Private Sub vlib_OnPlayStart(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnPlayStartEvent)
        MostraStatus(e.port, "(OnPlayStart) -> Iniciando Playback")
    End Sub
    'Ocorre sempre quando for finalizado o playback de qualquer mensagem.
    Private Sub vlib_OnPlayStop(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnPlayStopEvent)
        Select Case e.stopStatus
            Case ssStopped
                MostraStatus(e.port, "(OnPlayStop) -> Mensagem Interrompida Manualmente")
            Case ssDigitReceived
                MostraStatus(e.port, "(OnPlayStop) -> Mensagem Interrompida - Digito  " & vlib.ReadDigits(e.port).ToString())
            Case Else
                MostraStatus(e.port, "(OnPlayStop) -> Fim da Mensagem")
        End Select
    End Sub

    Private Sub vlib_OnRecording(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnRecordingEvent)
        MostraStatus(e.port, "(OnRecording) -> Gravando " & e.elapsedTime.ToString() & " segundos")
    End Sub

    Private Sub vlib_OnRecordStart(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnRecordStartEvent)
        MostraStatus(e.port, "(OnRecordStart) -> Gravando no Arquivo " & txtArquivoDeAudio.Text)
    End Sub

    Private Sub vlib_OnRecordStop(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnRecordStopEvent)
        Dim nRet As Short

        Select Case e.stopStatus
            Case ssStopped
                MostraStatus(e.port, "(OnRecordStop) -> Gravação Interrompida")
            Case ssDigitReceived
                MostraStatus(e.port, "(OnRecordStop) -> Gravação Interrompida - Digito " & vlib.ReadDigits(e.port).ToString())
            Case Else
                MostraStatus(e.port, "(OnRecordStop) -> Fim da Gravação")
        End Select

        If ckMonitorarAudio.Checked = False Then
            nRet = vlib.DisableInputBuffer(e.port)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(e.port, "(OnRecordStop) -> Erro ao desabilitar a gravação.nRet " & nRet.ToString())
            Else
                MostraStatus(e.port, "(OnRecordStop) -> Desabilitou inputbuffer")
            End If
        End If
    End Sub
    'Ocorre sempre quando for detectado o sinal de Ring na linha.
    Private Sub vlib_OnRingDetected(ByVal sender As Object, ByVal e As AxvoicerlibLib._DvoicerlibEvents_OnRingDetectedEvent)
        nContaRing = nContaRing + 1
        MostraStatus(e.port, "(OnRingDetected) -> " & nContaRing.ToString() & " Ring(s)")
    End Sub

    Private Sub btnLimpaLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLimpaLog.Click
        memStatus.Text = ""
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If vlib.DriverEnabled Then
            MessageBox.Show("Finalize o Driver antes de fechar a aplicação!", "Exemplo - Voicerlib", MessageBoxButtons.OK, MessageBoxIcon.Information)
            e.Cancel = True
        Else
            e.Cancel = False
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim sVersao As String = " "
        Dim nRet As Short

        'aloca espaco de 100 bytes para string
        Dim ptr As IntPtr = System.Runtime.InteropServices.Marshal.AllocHGlobal(300)

        DesabilitaTelaShutDown()
        'Mostra a versao da DLL
        nRet = vlib.GetLibVersion(ptr, 0)
        sVersao = System.Runtime.InteropServices.Marshal.PtrToStringAnsi(ptr)
        MostraStatus(0, "(OnFormLoad) - Versao Lib DLL:" & sVersao)
        'Mostra a versao da OCX
        nRet = vlib.GetLibVersion(ptr, 1)
        sVersao = System.Runtime.InteropServices.Marshal.PtrToStringAnsi(ptr)
        MostraStatus(0, "(OnFormLoad) - Versao Lib OCX:" & sVersao)

        'Libera memoria alocada
        System.Runtime.InteropServices.Marshal.FreeHGlobal(ptr)

    End Sub

    Private Sub btnGravar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGravar.Click
        Dim nRet As Short

        'Desabilita o input buffer
        nRet = vlib.DisableInputBuffer(Convert.ToInt16(txtCanal.Text))
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao desabilitar o input buffer.nRet " & nRet.ToString())
        Else
            MostraStatus(Convert.ToInt16(txtCanal.Text), "Desabilitou o input buffer")
        End If

        'Indica o formato de reproducao
        Select Case cbFormatoAudio.SelectedIndex
            Case 0 'ffWaveULaw
                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWaveULaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação")
                End If

            Case 1 'ffWavePCM
                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWavePCM)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação")
                End If

            Case 2 'ffGsm610
                vlib.SetGSMMode(GSM_DIGIVOICE)
                nRet = vlib.SetRecordFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação")
                End If

            Case 3 'ffWaveALaw
                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWaveALaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação")
                End If

            Case 4 'ffWave49
                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWave49)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação")
                End If

            Case 5
                vlib.SetGSMMode(GSM_RAW)
                nRet = vlib.SetRecordFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação.nRet " & nRet.ToString)
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação")
                End If
        End Select

        nRet = vlib.SetRecordGain(nPortaEmUso, Convert.ToInt16(txtGanhoGravacao.Text))
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, "Erro ao setar ganho de gravação.nRet " & nRet.ToString())
        End If

        nRet = vlib.EnableInputBuffer(nPortaEmUso, 0)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, "Erro ao habilitar a gravação.nRet " & nRet.ToString())
        Else
            MostraStatus(nPortaEmUso, "Habilitou input buffer")
        End If

        'Grava e finaliza com o termo indicado
        nRet = vlib.RecordFile(nPortaEmUso, txtArquivoDeAudio.Text, txtDigitoTerminador.Text)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, "Erro ao inicializar a gravação.nRet " & nRet.ToString())
        Else
            MostraStatus(nPortaEmUso, "Gravação inicializada com sucesso!")
        End If

    End Sub

    Private Sub btnPararGravacao_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPararGravacao.Click
        Dim nRet As Short

        If vlib.IsRecording(nPortaEmUso) Then
            'Para a gravacao
            nRet = vlib.StopRecordFile(nPortaEmUso)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao finalizar a gravação.nRet " & nRet.ToString())
            Else
                MostraStatus(nPortaEmUso, "Gravação finalizada com sucesso!")
            End If
        End If
    End Sub

    Private Sub btnAplicar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAplicar.Click
        Dim nRet As Short

        nRet = vlib.SetTwist(nPortaEmUso, txtTwist1.Text, txtTwist2.Text)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, "Erro ao configurar twist.nRet " & nRet.ToString())
        Else
            MostraStatus(nPortaEmUso, "Twist configurado para a porta corrente! Twist1:" & txtTwist1.Text & " Twist2:" & txtTwist2.Text)
        End If
    End Sub

    Private Sub chkHabilitaFSK_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkHabilitaFSK.CheckedChanged
        Dim i As Short

        If chkHabilitaFSK.Checked = False Then
            For i = 1 To vlib.GetPortsCount
                vlib.EnableFSKDetection(i, 0, 0)
            Next
        Else
            For i = 1 To vlib.GetPortsCount
                vlib.EnableFSKDetection(i, 1, 0)
            Next
        End If
    End Sub

    Private Sub btnOpenDialogArquivoAudio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenDialogArquivoAudio.Click
        If OpenFileDialog.ShowDialog() = Windows.Forms.DialogResult.OK Then
            txtArquivoDeAudio.Text = OpenFileDialog.FileName
        End If
    End Sub

    Private Sub txtCanal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCanal.Click
        Dim nRet As Integer

        If ckMonitorarAudio.Checked Then
            If vlib.IsRecording(nPortaEmUso) Then
                'Para gravacao
                nRet = vlib.StopRecordFile(nPortaEmUso)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao interromper gravação.nRet " & nRet.ToString())
                End If

                'Desabilita InputBuffer
                nRet = vlib.DisableInputBuffer(nPortaEmUso)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao desabilitar Input Buffer.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Desabilitou inputbuffer")
                End If

            End If
            'Desabilita monitoracao de audio
            nRet = vlib.AudioMonitor(nPortaEmUso, DG_DISABLE)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao desabilitar monitoração de audio.nRet " & nRet.ToString())
            End If
        End If

        nPortaEmUso = Convert.ToInt16(txtCanal.Text)

        If nPortaEmUso < txtCanal.Minimum Then
            nPortaEmUso = txtCanal.Minimum
        End If

        If nPortaEmUso > txtCanal.Maximum Then
            nPortaEmUso = txtCanal.Maximum
        End If

        If ckMonitorarAudio.Checked Then
            nRet = vlib.DisableInputBuffer(nPortaEmUso)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao desabilitar input buffer.nRet " & nRet.ToString())
            Else
                MostraStatus(nPortaEmUso, "Desabilitou o input buffer")
            End If
            'Habilita InputBuffer
            nRet = vlib.EnableInputBuffer(nPortaEmUso, DG_DISABLE_AGC)
            If (nRet <> DG_EXIT_SUCCESS) And (nRet <> DG_ERROR_THREAD_ALREADY_RUNNING) Then
                MostraStatus(nPortaEmUso, "Erro ao habilitar input buffer.nRet " & nRet.ToString())
            Else
                MostraStatus(nPortaEmUso, "Habilitou InputBuffer")
            End If
            'Habilita monitoracao de audio
            vlib.AudioMonitor(nPortaEmUso, DG_ENABLE)
        End If


    End Sub

    Private Sub txtSensPulso_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSensPulso.Click
        Dim nRet As Short
        Dim nForCanal As Short

        If vlib.DriverEnabled Then
            'Modifica a frequencia de supervisao
            For nForCanal = nCanalInicial To nCanalFinal
                nRet = vlib.EnablePulseDetection(nForCanal, e.ToString)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao alterar a sensibilidade de pulso.nRet " & nRet.ToString())
                Else
                    MostraStatus(nForCanal, "Sensibilidade de pulso alterada")
                End If
            Next
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub txtLimiarSilencio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtLimiarSilencio.Click
        Dim nRet As Short
        Dim nForCanal As Short

        If vlib.DriverEnabled Then
            'Altera o limiar para deteccao de atendimento
            For nForCanal = nCanalInicial To nCanalFinal
                nRet = vlib.SetSilenceThreshold(nForCanal, e.ToString)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nForCanal, "Erro ao setar limiar para detecção de atendimento.nRet " & nRet.ToString())
                Else
                    MostraStatus(nForCanal, "Limiar para detecção de atendimento alterada")
                End If
            Next
        End If
    End Sub

    Private Sub txtGanhoGravacao_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtGanhoGravacao.Click
        Dim nRet As Short

        If vlib.DriverEnabled Then
            nRet = vlib.SetRecordGain(nPortaEmUso, Convert.ToInt16(txtGanhoGravacao.Text))
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(nPortaEmUso, "Erro ao setar 'Ganho de Gravacao'.nRet " & nRet.ToString())
            Else
                MostraStatus(nPortaEmUso, "Ganho de gravação alterado para " & txtGanhoGravacao.Text)
            End If
        Else
            MostraStatus(0, "ATENÇÃO: O Driver Não Está Inicializado")
        End If
    End Sub

    Private Sub txtCaminhoStockSigs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCaminhoStockSigs.Click
        vlib.StockSigPath = txtCaminhoStockSigs.Text
    End Sub

    Private Sub ckMonitorarAudio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckMonitorarAudio.Click
        Dim nRet As Integer

        If ckMonitorarAudio.Checked Then
            nRet = vlib.DisableInputBuffer(Convert.ToInt16(txtCanal.Text))
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao desabilitar input buffer.nRet " & nRet.ToString())
            Else
                MostraStatus(Convert.ToInt16(txtCanal.Text), "Desabilitou input buffer")
            End If

            'Habilita input buffer
            nRet = vlib.EnableInputBuffer(Convert.ToInt16(txtCanal.Text), DG_ENABLE_AGC)
            If ((nRet <> DG_EXIT_SUCCESS) And (nRet <> DG_ERROR_THREAD_ALREADY_RUNNING)) Then
                MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao habilitar input buffer.nRet " & nRet.ToString())
            Else
                MostraStatus(Convert.ToInt16(txtCanal.Text), "Habilitou input buffer com sucesso")
            End If

            'Liga a monitoracao do audio
            nRet = vlib.AudioMonitor(Convert.ToInt16(txtCanal.Text), DG_ENABLE)
            If nRet <> DG_EXIT_SUCCESS Then
                MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao habilitar monitoração do audio.nRet " & nRet.ToString())
            End If
        Else
            If vlib.IsRecording(Convert.ToInt16(txtCanal.Text)) = False Then
                'Desliga monitoracao do audio
                nRet = vlib.AudioMonitor(Convert.ToInt16(txtCanal.Text), DG_DISABLE)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao desabilitar monitoração do audio.nRet " & nRet.ToString())
                End If

                'Desabilita InputBuffer
                nRet = vlib.DisableInputBuffer(Convert.ToInt16(txtCanal.Text))
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Erro ao desabilitar input buffer .nRet " & nRet.ToString())
                Else
                    MostraStatus(Convert.ToInt16(txtCanal.Text), "Desabilitou input buffer - chk")
                End If

            End If
        End If

    End Sub

    Private Sub cbFormatoAudio_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbFormatoAudio.SelectedIndexChanged
        Dim nRet As Short

        'Indica o formato de reproducao e gravacao
        Select Case cbFormatoAudio.SelectedIndex

            Case 0 'ffWaveULaw
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWaveULaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução como ffWaveULaw.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de reprodução como ffWaveULaw")
                End If

                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWaveULaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação como ffWaveULaw.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação como ffWaveULaw")
                End If

            Case 1 'ffWavePCM
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWavePCM)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução como ffWavePCM.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de reprodução como ffWavePCM")
                End If

                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWavePCM)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação como ffWavePCM.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação como ffWavePCM")
                End If

            Case 2 'ffGsm610
                vlib.SetGSMMode(GSM_DIGIVOICE)
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução como ffGsm610.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de reprodução como ffGsm610")
                End If

                nRet = vlib.SetRecordFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação como ffGsm610.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação como ffGsm610")
                End If

            Case 3 'ffWaveALaw
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWaveALaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução como ffWaveALaw.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de reprodução como ffWaveALaw")
                End If

                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWaveALaw)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação como ffWaveALaw.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação como ffWaveALaw")
                End If

            Case 4 'ffWave49
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffWave49)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução como ffWave49.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de reprodução como ffWave49")
                End If

                nRet = vlib.SetRecordFormat(nPortaEmUso, ffWave49)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação como ffWave49.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação como ffWave49")
                End If

            Case 5 'ffGsmRaw
                vlib.SetGSMMode(GSM_RAW)
                nRet = vlib.SetPlayFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de reprodução GSM.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de reprodução como GSM")
                End If

                nRet = vlib.SetRecordFormat(nPortaEmUso, ffGsm610)
                If nRet <> DG_EXIT_SUCCESS Then
                    MostraStatus(nPortaEmUso, "Erro ao setar formato de gravação GSM.nRet " & nRet.ToString())
                Else
                    MostraStatus(nPortaEmUso, "Setou formato de gravação como GSM")
                End If

        End Select
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim nRet As Short

        'Gera tom
        vlib.SetDigitFrequency(1, 9, 0, 48, 1100)
        vlib.SetDigitFrequency(1, 9, 1, 48, 0)
        nRet = vlib.GenerateMF(nPortaEmUso, GENERATE_MF, 0)
        If nRet <> DG_EXIT_SUCCESS Then
            MostraStatus(nPortaEmUso, nRet, "(OnAfterMakeCall) - GenerateMF")
        Else
            MostraStatus(nPortaEmUso, "(OnAfterMakeCall) - Gerou tom...")
        End If

    End Sub

End Class
